/*
 *   08-19-1990 
 *
 *   Pierluigi Sanzani
 *   Via Paride Pasquali, 3
 *   40134 - Bologna, Italy.
 *
 *
 *   I have found TWO VERY DANGEROUS bugs in the Microsoft C compiler,
 *   (release 5.1 and 6.0). 
 * 
 *   First bug:   In the listings below you can see that the compiler 
 *                does NOT detect a mistake in the variable d,e,f 
 *                declaration section.
 *     
 *   Second bug:  When you use d,e,f you have three integers, not three
 *                floats. (You can check the assembly listing). So you
 *                may have a loss of precision, or you may overwrite
 *                memory at runtime if you have declared d,e,f as 
 *                external in another c source file.  
 * 
 */
 
float a,  b,  c;        // <-- the programmer mistake
      d,  e,  f;

main()
 {  
   a = 1.0f;
   b = 2.0f;
   c = 3.0f;
   d = 1.0f;            
   e = 2.0f;
   f = 3.0f; 
 }

#ifdef #NOTDEFME
;
; Assembly listing produced with the statement  cl /AL /c /Fa error.c
;
;
;       Static Name Aliases
;
	TITLE   error.c
	.8087
INCLUDELIB      LLIBCE
ERROR_TEXT      SEGMENT  WORD PUBLIC 'CODE'
ERROR_TEXT      ENDS
_DATA   SEGMENT  WORD PUBLIC 'DATA'
_DATA   ENDS
CONST   SEGMENT  WORD PUBLIC 'CONST'
CONST   ENDS
_BSS    SEGMENT  WORD PUBLIC 'BSS'
_BSS    ENDS
DGROUP  GROUP   CONST, _BSS, _DATA
	ASSUME DS: DGROUP, SS: DGROUP
EXTRN   __acrtused:ABS
EXTRN   __aFchkstk:FAR
_BSS      SEGMENT
COMM NEAR       _a:     BYTE:    4
COMM NEAR       _b:     BYTE:    4
COMM NEAR       _c:     BYTE:    4
COMM NEAR       _d:     BYTE:    2  <--- the compiler mistake !
COMM NEAR       _e:     BYTE:    2
COMM NEAR       _f:     BYTE:    2
EXTRN   __fltused:NEAR
_BSS      ENDS
ERROR_TEXT      SEGMENT
	ASSUME  CS: ERROR_TEXT
; Line 1
ERROR_TEXT      ENDS
CONST      SEGMENT
$T20000 DD      03f800000r   ;  1.0000000
$T20001 DD      040000000r   ;  2.0000000
$T20002 DD      040400000r   ;  3.0000000
CONST      ENDS
ERROR_TEXT      SEGMENT
	ASSUME  CS: ERROR_TEXT
; Line 6
ERROR_TEXT      ENDS
CONST      SEGMENT
$T20004 DW SEG _a 
$T20005 DW SEG _b 
$T20006 DW SEG _c 
$T20007 DW SEG _d 
$T20008 DW SEG _e 
$T20009 DW SEG _f 
CONST      ENDS
ERROR_TEXT      SEGMENT
	ASSUME  CS: ERROR_TEXT
	PUBLIC  _main
_main   PROC FAR
	xor     ax,ax
	call    FAR PTR __aFchkstk
; Line 7
	mov     ax,WORD PTR $T20000
	mov     dx,WORD PTR $T20000+2
	mov     es,WORD PTR $T20004
	mov     WORD PTR es:_a,ax
	mov     WORD PTR es:_a+2,dx
; Line 8
	mov     ax,WORD PTR $T20001
	mov     dx,WORD PTR $T20001+2
	mov     es,WORD PTR $T20005
	mov     WORD PTR es:_b,ax
	mov     WORD PTR es:_b+2,dx
; Line 9
	mov     ax,WORD PTR $T20002
	mov     dx,WORD PTR $T20002+2
	mov     es,WORD PTR $T20006
	mov     WORD PTR es:_c,ax
	mov     WORD PTR es:_c+2,dx
; Line 10
	mov     es,WORD PTR $T20007     
	mov     WORD PTR es:_d,1
; Line 11
	mov     es,WORD PTR $T20008
	mov     WORD PTR es:_e,2
; Line 12
	mov     es,WORD PTR $T20009
	mov     WORD PTR es:_f,3
; Line 13
	ret     
	nop     

_main   ENDP
ERROR_TEXT      ENDS
END


